;==========================================
; P-Balloon Enhancement
; By Erik
;
; This patch includes a bunch of features
; that help enhancing the P-Balloon.
;==========================================

!lose_on_powerdown   = 0    ;   set to 0 to make Mario keep the Balloon when he loses a powerup
!x_speed_accel       = 1    ;   set to 1 to allow to accelerate the speed when pressing the run buttons on the x axis (speed table below)
!fix_lr_bug          = 1    ;   set to 1 to fix the bug when pressing left and right on the D-pad at the same time

if read1($00FFD5) == $23
    sa1rom
    !addr = $6000
    !bank = $000000
    !9E = $3200
else
    lorom
    !addr = $0000
    !bank = $800000
    !9E = $9E
endif

if !lose_on_powerdown == 0
       org $019FC0
              CMP #$02
else
       org $019FC0
              CMP #$01
endif
if !x_speed_accel
org $02D229
       autoclean JML x_speed_hijack

freecode
x_speed_hijack:
       LDA !9E,x
       CMP #$7D
       BEQ .balloon
.return
       if !fix_lr_bug = 1
              CPY #$03
              BNE .not_both
       .pressing_both
              JML $02D247|!bank
       .not_both
       endif
       CPY #$01
       BNE +
       JML $02D22D|!bank
+      JML $02D238|!bank

.balloon
       BIT $15
       BVC .return
       if !fix_lr_bug = 1
              CPY #$03
              BEQ .pressing_both
       endif
       TYX
       LDY $15E9|!addr
       CPX #$01
       BNE .right
       LDA.w $B6,y
       CMP.l new_max_x_speeds-1,x
       BEQ .cont_y_speeds
       BPL .slow_down
       BRA .cont_x_speeds
.cont_y_speeds
       TYX
       JML $02D247|!bank
.slow_down
       TYX
       JML $02D21A|!bank

.right
       LDA.w $B6,y
       CMP.l new_max_x_speeds-1,x
       BEQ .cont_y_speeds
       BMI .slow_down

.cont_x_speeds
       CLC
       ADC.l new_add_x_speeds-1,x
       TYX
       STA $B6,x
       JML $02D247|!bank

new_add_x_speeds:
       db $02,$FE
new_max_x_speeds:
       db $20,$E0

else
org $02D229
       CPY #$01
       BNE $0B
endif